//Frustum  ᪠७ ७ 
//#define Lmd(x)  $FLD DSDWORD [x*4+EAX] 
//#define Lproj(x)  $FLD DSDWORD [x*4+ECX] 

:struct CPlane {


// This function will simply perform a dot product of the point and this plane.


      float a;
      float b;
      float c;
      float d;

      st stdcall GetDistance(int i, float x, float y, float z);

};


#define MAX_SIDES       6

:CPlane Frustum[MAX_SIDES];


:float clip[16]=0.0f;

:float proj[16]=0.0f;
:float model[16]=0.0f;



// This function will simply perform a dot product of the point and -------------------------
// this plane.

//   return a * x + b * y + c * z + d;
:st stdcall CPlane::GetDistance(int i, float x, float y, float z)
{

float aa, bb, cc, dd;

aa=Frustum[i].a;
bb=Frustum[i].b;
cc=Frustum[i].c;
dd=Frustum[i].d;

       $FLD aa  
       $FMUL SSDWORD[#x]

       $FLD bb
       $FMUL SSDWORD[#y]

       $faddp

       $FLD cc
       $FMUL SSDWORD[#z]

       $faddp

       $FADD dd;

}




#define LoadMul(x, y) {$FLD DSDWORD [x*4+EAX]; $FMUL DSDWORD[y*4+ECX];}
#define AllADDP() {$FADDP st(1); $FADDP st(1); $FADDP st(1);}
#define SaveClip(x) $FSTP DSDWORD[x*4+EBX]





///////////////////////////////// BOX IN FRUSTUM \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This determines if a BOX is in or around our frustum by it's min and max points
/////
///////////////////////////////// BOX IN FRUSTUM \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

BOOLEAN isBoxVisiable( float x, float y, float z, float x2, float y2, float z2)
{
int i;
float compare;

	// Go through all of the corners of the box and check then again each plane
	// in the frustum.  If all of them are behind one of the planes, then it most
	// like is not in the frustum.
	for( i = 0; i < MAX_SIDES; i++ )
	{

         compare=Frustum.GetDistance(i, x, y, z);
         if(compare > 0.0)   {zaplatka1;  continue;}
         zaplatka1;

         compare=Frustum.GetDistance(i, x2, y, z);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x, y2, z);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x2, y2, z);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x, y, z2);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x2, y, z2);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x, y2, z2);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;

         compare=Frustum.GetDistance(i, x2, y2, z2);
         if(compare > 0.0)  {zaplatka1;  continue;}
	 zaplatka1;


	return FALSE;
        }

/*
		if(m_Frustum[i][A] * x  + m_Frustum[i][B] * y  + m_Frustum[i][C] * z  + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x2 + m_Frustum[i][B] * y  + m_Frustum[i][C] * z  + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x  + m_Frustum[i][B] * y2 + m_Frustum[i][C] * z  + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x2 + m_Frustum[i][B] * y2 + m_Frustum[i][C] * z  + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x  + m_Frustum[i][B] * y  + m_Frustum[i][C] * z2 + m_Frustum[i][D] > 0)  continue;

!		if(m_Frustum[i][A] * x2 + m_Frustum[i][B] * y  + m_Frustum[i][C] * z2 + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x  + m_Frustum[i][B] * y2 + m_Frustum[i][C] * z2 + m_Frustum[i][D] > 0)  continue;

		if(m_Frustum[i][A] * x2 + m_Frustum[i][B] * y2 + m_Frustum[i][C] * z2 + m_Frustum[i][D] > 0)  continue;

		// If we get here, it isn't in the frustum
		return false;
*/

	

	// Return a true for the box being inside of the frustum
	return TRUE;
}




//஢ 室  BOX   .
:BOOLEAN isCubeVisiable(DWORD LpCenter, float size)
{
   int i;
   float minX, maxX;
   float minY, maxY;
   float minZ, maxZ;

   float compare;

   float x, y, z;   //

x=DSFLOAT[LpCenter+#coordinate3D.x];
y=DSFLOAT[LpCenter+#coordinate3D.y];
z=DSFLOAT[LpCenter+#coordinate3D.z];


   // Calculate the bounding box.
   minX = x - size; maxX = x + size;
   minY = y - size; maxY = y + size;
   minZ = z - size; maxZ = z + size;


/*
   // Calculate the bounding box.
   minX = x - size; maxX = x + size;
   minY = y - size; maxY = y + size;
   minZ = z - size; maxZ = z + size;

*/


/*
minX=1.0f;     maxX=10.0f;
minY=1.0f;     maxY=10.0f;
minZ=1.0f;     maxZ=10.0f;
*/

/*
ESI=LpBBox;
$FLD DSFLOAT[ESI]
$FSTP SSFLOAT[#minX]

$FLD DSFLOAT[ESI+4]
$FSTP SSFLOAT[#minY]

$FLD DSFLOAT[ESI+4+4]
$FSTP SSFLOAT[#minZ]

$FLD DSFLOAT[ESI+4+4+4]
$FSTP SSFLOAT[#maxX]

$FLD DSFLOAT[ESI+4+4+4+4]
$FSTP SSFLOAT[#maxY]

$FLD DSFLOAT[ESI+4+4+4+4+4]
$FSTP SSFLOAT[#maxZ]
*/


   // Loop through each side of the frustum and test if the box lies outside any of them.



   for(i = 0; i < MAX_SIDES; i++)      
      {

         compare=Frustum.GetDistance(i, minX, minY, minZ);
         if(compare > size) {zaplatka1;  continue;}
         zaplatka1;
         compare=Frustum.GetDistance(i, maxX, minY, minZ);
	 if(compare > size)  {zaplatka1;  continue;}
         zaplatka1;
         compare=Frustum.GetDistance(i, minX, maxY, minZ);
	 if(compare > size)  {zaplatka1;  continue;}
         zaplatka1;
	 compare=Frustum.GetDistance(i, maxX, maxY, minZ);
	 if(compare > size)  {zaplatka1;  continue;}
         zaplatka1;
	 compare=Frustum.GetDistance(i, minX, minY, maxZ);
	 if(compare > size)  {zaplatka1;  continue;}
         zaplatka1;
	 compare=Frustum.GetDistance(i, maxX, minY, maxZ);
	 if(compare > size)   {zaplatka1;  continue;}
         zaplatka1;
	 compare=Frustum.GetDistance(i, minX, maxY, maxZ);
	 if(compare > size)  {zaplatka1;  continue;}
         zaplatka1;
	 compare=Frustum.GetDistance(i, maxX, maxY, maxZ);
	 if(compare > size) {zaplatka1;  continue;}
         zaplatka1;

         return FALSE;

      }



   return TRUE;
}



//-------------------------------------------------------------------------

:void NormalizeFrustum()
{
  int i;
  float magnitude = 0.0f;

   // Loop through each side of the frustum and normalize it.
   for( i = 0; i < MAX_SIDES; i++)
      {



//         magnitude = (float)sqrt(Frustum[i].a * Frustum[i].a + 
//			   		               Frustum[i].b * Frustum[i].b + 
//						               Frustum[i].c * Frustum[i].c);
st(1)=Frustum[i].a * Frustum[i].a;
st(2)=Frustum[i].b * Frustum[i].b;
st(3)=Frustum[i].c * Frustum[i].c;
//st=st(1)+st(2)+st(3);
$FFREE st;  //ᮢ st
$FINCSTP;   //㫨
$FADDP st(1);
$FADDP st(1);
$FSTP SSDWORD[#magnitude];

			magnitude=sqrt(magnitude);
		        magnitude = 1.0 / magnitude;
                     



	      Frustum[i].a *= magnitude;
	      Frustum[i].b *= magnitude;
	      Frustum[i].c *= magnitude;
	      Frustum[i].d *= magnitude;




//-   st 祭   ᫥饩 ୮ ࠡ 
$FFREE st;  //ᮢ st
$FINCSTP;   //㫨
$FFREE st;  //ᮢ st
$FINCSTP;   //㫨

      }

}


//-------------------------------------------------------------------------
:fastcall CalculateFrustum(EAX,  ECX)
{

//EAX=#Frustum;
//NormalizeFrustum();

//clip[1]=1.0f;
//clip[2]=1.0f;

/*
//  ᨢ 㯥  ਤ㬠
float clip[16];
int i=0;
EAX=#clip;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
i++;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
i++;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
i++;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
i++;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
1i++;
DSDWORD[i*sizeof(float)+#clip]=1.0f;
*/


// Create the clip.
//clip[0] = md[0] * proj[0] + md[1] * proj[4] + md[2] * proj[8]  + md[3] * proj[12];
EBX=#clip;

LoadMul(0, 0);
LoadMul(1, 4);
LoadMul(2, 8);
LoadMul(3, 12);
AllADDP();
SaveClip(0);
//clip[1] = md[0] * proj[1] + md[1] * proj[5] + md[2] * proj[9]  + md[3] * proj[13];
LoadMul(0, 1);
LoadMul(1, 5);
LoadMul(2, 9);
LoadMul(3, 13);
AllADDP();
SaveClip(1);
//clip[2] = md[0] * proj[2] + md[1] * proj[6] + md[2] * proj[10] + md[3] * proj[14];
LoadMul(0, 2);
LoadMul(1, 6);
LoadMul(2, 10);
LoadMul(3, 14);
AllADDP();
SaveClip(2);
//	clip[3] = md[0] * proj[3] + md[1] * proj[7] + md[2] * proj[11] + md[3] * proj[15];
LoadMul(0, 3);
LoadMul(1, 7);
LoadMul(2, 11);
LoadMul(3, 15);
AllADDP();
SaveClip(3);
//-----------------



//clip[4] = md[4] * proj[0] + md[5] * proj[4] + md[6] * proj[8]  + md[7] * proj[12];
LoadMul(4, 0);
LoadMul(5, 4);
LoadMul(6, 8);
LoadMul(7, 12);
AllADDP();
SaveClip(4);
//clip[5] = md[4] * proj[1] + md[5] * proj[5] + md[6] * proj[9]  + md[7] * proj[13];
LoadMul(4, 1);
LoadMul(5, 5);
LoadMul(6, 9);
LoadMul(7, 13);
AllADDP();
SaveClip(5);
//	clip[6] = md[4] * proj[2] + md[5] * proj[6] + md[6] * proj[10] + md[7] * proj[14];
LoadMul(4, 2);
LoadMul(5, 6);
LoadMul(6, 10);
LoadMul(7, 14);
AllADDP();
SaveClip(6);
//	clip[7] = md[4] * proj[3] + md[5] * proj[7] + md[6] * proj[11] + md[7] * proj[15];
LoadMul(4, 3);
LoadMul(5, 7);
LoadMul(6, 11);
LoadMul(7, 15);
AllADDP();
SaveClip(7);
//-----------------

//	clip[8]  = md[8] * proj[0] + md[9] * proj[4] + md[10] * proj[8]  + md[11] * proj[12];
LoadMul(8, 0);
LoadMul(9, 4);
LoadMul(10, 8);
LoadMul(11, 12);
AllADDP();
SaveClip(8);
//	clip[9]  = md[8] * proj[1] + md[9] * proj[5] + md[10] * proj[9]  + md[11] * proj[13];
LoadMul(8, 1);
LoadMul(9, 5);
LoadMul(10, 9);
LoadMul(11, 13);
AllADDP();
SaveClip(9);
//	clip[10] = md[8] * proj[2] + md[9] * proj[6] + md[10] * proj[10] + md[11] * proj[14];
LoadMul(8, 2);
LoadMul(9, 6);
LoadMul(10, 10);
LoadMul(11, 14);
AllADDP();
SaveClip(10);
//	clip[11] = md[8] * proj[3] + md[9] * proj[7] + md[10] * proj[11] + md[11] * proj[15];
LoadMul(8, 3);
LoadMul(9, 7);
LoadMul(10, 11);
LoadMul(11, 15);
AllADDP();
SaveClip(11);
//-----------------


//	clip[12] = md[12] * proj[0] + md[13] * proj[4] + md[14] * proj[8]  + md[15] * proj[12];
LoadMul(12, 0);
LoadMul(13, 4);
LoadMul(14, 8);
LoadMul(15, 12);
AllADDP();
SaveClip(12);
//	clip[13] = md[12] * proj[1] + md[13] * proj[5] + md[14] * proj[9]  + md[15] * proj[13];
LoadMul(12, 1);
LoadMul(13, 5);
LoadMul(14, 9);
LoadMul(15, 13);
AllADDP();
SaveClip(13);
//	clip[14] = md[12] * proj[2] + md[13] * proj[6] + md[14] * proj[10] + md[15] * proj[14];
LoadMul(12, 2);
LoadMul(13, 6);
LoadMul(14, 10);
LoadMul(15, 14);
AllADDP();
SaveClip(14);
//	clip[15] = md[12] * proj[3] + md[13] * proj[7] + md[14] * proj[11] + md[15] * proj[15];
LoadMul(12, 3);
LoadMul(13, 7);
LoadMul(14, 11);
LoadMul(15, 15);
AllADDP();
SaveClip(15);



// Calculate the right side of the frustum.
// 室 A, B, C, D   ᪮    
//   Frustum[0].a = clip[3]  - clip[0];
Frustum[0].a=DSFLOAT[3*sizeof(float)+#clip] - DSFLOAT[0*sizeof(float)+#clip];
//Frustum[0].b = clip[7]  - clip[4];
Frustum[0].b=DSFLOAT[7*sizeof(float)+#clip] - DSFLOAT[4*sizeof(float)+#clip];
//Frustum[0].c = clip[11] - clip[8];
Frustum[0].c=DSFLOAT[11*sizeof(float)+#clip] - DSFLOAT[8*sizeof(float)+#clip];
//Frustum[0].d = clip[15] - clip[12];
Frustum[0].d=DSFLOAT[15*sizeof(float)+#clip] - DSFLOAT[12*sizeof(float)+#clip];


// Calculate the left side of the frustum.
// 室 A, B, C, D   ᪮ 
//	Frustum[1].a = clip[3]  + clip[0];
Frustum[1].a=DSFLOAT[3*sizeof(float)+#clip] + DSFLOAT[0*sizeof(float)+#clip];
//	Frustum[1].b = clip[7]  + clip[4];
Frustum[1].b=DSFLOAT[7*sizeof(float)+#clip] + DSFLOAT[4*sizeof(float)+#clip];
//	Frustum[1].c = clip[11] + clip[8];
Frustum[1].c=DSFLOAT[11*sizeof(float)+#clip] + DSFLOAT[8*sizeof(float)+#clip];
//	Frustum[1].d = clip[15] + clip[12];
Frustum[1].d=DSFLOAT[15*sizeof(float)+#clip] + DSFLOAT[12*sizeof(float)+#clip];


// Calculate the bottom side of the frustum.
// 室 A, B, C, D   ᪮ 
//	Frustum[2].a = clip[3]  + clip[1];
Frustum[2].a=DSFLOAT[3*sizeof(float)+#clip] + DSFLOAT[1*sizeof(float)+#clip];
//	Frustum[2].b = clip[7]  + clip[5];
Frustum[2].b=DSFLOAT[7*sizeof(float)+#clip] + DSFLOAT[5*sizeof(float)+#clip];
//	Frustum[2].c = clip[11] + clip[9];
Frustum[2].c=DSFLOAT[11*sizeof(float)+#clip] + DSFLOAT[9*sizeof(float)+#clip];
//	Frustum[2].d = clip[15] + clip[13];
Frustum[2].d=DSFLOAT[15*sizeof(float)+#clip] + DSFLOAT[13*sizeof(float)+#clip];


// Calculate the top side of the frustum.
//  ᪮ 
//	Frustum[3].a = clip[3]  - clip[1];
//	Frustum[3].b = clip[7]  - clip[5];
//	Frustum[3].c = clip[11] - clip[9];
//	Frustum[3].d = clip[15] - clip[13];
Frustum[3].a=DSFLOAT[3*sizeof(float)+#clip] - DSFLOAT[1*sizeof(float)+#clip];
Frustum[3].b=DSFLOAT[7*sizeof(float)+#clip] - DSFLOAT[5*sizeof(float)+#clip];
Frustum[3].c=DSFLOAT[11*sizeof(float)+#clip] - DSFLOAT[9*sizeof(float)+#clip];
Frustum[3].d=DSFLOAT[15*sizeof(float)+#clip] - DSFLOAT[13*sizeof(float)+#clip];


// Calculate the far side of the frustum.
//  ᪮ 
//	Frustum[4].a = clip[3]  - clip[2];
//	Frustum[4].b = clip[7]  - clip[6];
//	Frustum[4].c = clip[11] - clip[10];
//	Frustum[4].d = clip[15] - clip[14];
Frustum[4].a=DSFLOAT[3*sizeof(float)+#clip] - DSFLOAT[2*sizeof(float)+#clip];
Frustum[4].b=DSFLOAT[7*sizeof(float)+#clip] - DSFLOAT[6*sizeof(float)+#clip];
Frustum[4].c=DSFLOAT[11*sizeof(float)+#clip] - DSFLOAT[10*sizeof(float)+#clip];
Frustum[4].d=DSFLOAT[15*sizeof(float)+#clip] - DSFLOAT[14*sizeof(float)+#clip];



// Calculate the near side of the frustum.
//  ᪮ 
//	Frustum[5].a = clip[3]  + clip[2];
//	Frustum[5].b = clip[7]  + clip[6];
//	Frustum[5].c = clip[11] + clip[10];
//	Frustum[5].d = clip[15] + clip[14];

Frustum[5].a=DSFLOAT[3*sizeof(float)+#clip] + DSFLOAT[2*sizeof(float)+#clip];
Frustum[5].b=DSFLOAT[7*sizeof(float)+#clip] + DSFLOAT[6*sizeof(float)+#clip];
Frustum[5].c=DSFLOAT[11*sizeof(float)+#clip] + DSFLOAT[10*sizeof(float)+#clip];
Frustum[5].d=DSFLOAT[15*sizeof(float)+#clip] + DSFLOAT[14*sizeof(float)+#clip];


// Normalize the sides of the frustum.
   NormalizeFrustum();

}



//----------------------------------------------------------------------------------
:void glGrabMatrixFrustumCalculate(){

   // Grab the model view matrix and the projection matrix and store them in our arrays.
   glGetFloatv(GL_PROJECTION_MATRIX, #proj);
   glGetFloatv(GL_MODELVIEW_MATRIX, #model);



   CalculateFrustum(#model, #proj);

}


//--------------------------------------------------------------------------------------------
