//     
#include "INC/bitmask-1_3/bitmask.OBJ"

struct bitmask
{
  int w,h;    //    
  DWORD bits; //   
};


//  :
//
/* Creates a bitmask of width w and height h.
 * The mask is automatically cleared when created.
 */

//bitmask_t *bitmask_create(int w, int h);                   //  
//void bitmask_free(bitmask_t *m);                           //    

//void bitmask_clear(bitmask_t *m);                          //   00
//void bitmask_fill(bitmask_t *m);                           //   FF

/* Returns nonzero if the bit at (x,y) is set. 
 * Coordinates start at (0,0)
 */
//static INLINE int bitmask_getbit(const bitmask_t *m,int x,int y)  //     
//{ 
//  return m->bits[x/BITW_LEN*m->h + y] & BITN(x & BITW_MASK); 
//}

/* Sets the bit at (x,y) */                                         //  
//static INLINE void bitmask_setbit(bitmask_t *m,int x,int y)
//{ 
//  m->bits[x/BITW_LEN*m->h + y] |= BITN(x & BITW_MASK); 
//}

/* Clears the bit at (x,y) */                                      //    
//static INLINE void bitmask_clearbit(bitmask_t *m,int x,int y)
//{ 
//  m->bits[x/BITW_LEN*m->h + y] &= ~BITN(x & BITW_MASK); 
//}

/* Returns nonzero if the masks overlap with the given offset. */
//int bitmask_overlap(const bitmask_t *a,const bitmask_t *b,int xoffset, int yoffset);  //  ,          

/* Like bitmask_overlap(), but will also give a point of intersection.         //   
 * x and y are given in the coordinates of mask a, and are untouched
 * if there is no overlap.
 */
//int bitmask_overlap_pos(const bitmask_t *a,const bitmask_t *b,
//			int xoffset, int yoffset, int *x, int *y);

/* Returns the number of overlapping 'pixels' */                                //     
//int bitmask_overlap_area(const bitmask_t *a,const bitmask_t *b,int xoffset, int yoffset);

/* Draws mask b onto mask a (bitwise OR)                                          //  
 * Can be used to compose large (game background?) mask from 
 * several submasks, which may speed up the testing. 
 */
//void bitmask_draw(bitmask_t *a,bitmask_t *b,int xoffset, int yoffset);


 //LpRGBA      RGBA
//   x, y
//  h, w
//-  n
/*
int unsigned CreateBitMaskFromRGBA(int unsigned LpRGBA, 
                               int nTextureWidth, int nTextureHeight, 
                               int nFrameWidth,   int nFrameHeight,
                               int nNumFrameColumns, int nNumFrameRows, 
                               int nTotalFrames,
                               int nOffsetX, int nOffsetY)
{
	
	int i,  h;
	DWORD f;
	BYTE b;
	int bytes_count;
	
//==============================	
  DWORD LpBuffer, LpBufferEnd=0;	
  DWORD LpTOP,  LpROW, LpBOT;


//  ---------------------------------------------------------
int dst_height, dst_width, y, x, y_src, y_dst, src_pitch, dst_pitch;
DWORD LpMaskaFrame;

//--------------------------------------------------------------------------------- 

//LpBuffer=LocalAlloc(LPTR,64*64);	
LpBuffer=LocalAlloc(LPTR,nTextureWidth*nTextureHeight);	
//LpBufferEnd=nTextureWidth*nTextureHeight-1+LpBuffer;
LpBufferEnd=LpBuffer;

/*
f=CreateFile("maska.raw", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, 0 );
	 WriteFile( f, #b, 1, #bytes_count, NULL );
CloseHandle(f);
*/

//   
	FOR (i=0; i<nTextureWidth*nTextureHeight; i++)
{
	 EAX=DSDWORD[i*4+LpRGBA];
	 b=AL;
	 DSBYTE[LpBufferEnd]=b;
   LpBufferEnd++;   
	}

//  flip   X =====================================
//  ********
//  ******** 
//------------------------------------->X
//  %%%%%%%% 
//  %%%%%%%%

LpROW=LocalAlloc(LPTR, nTextureWidth);	
 FOR (h = 0; h < nTextureHeight / 2; h++) {

      LpTOP=h*nTextureWidth+LpBuffer;
			LpBOT=nTextureHeight - h - 1 * nTextureWidth + LpBuffer;
	
  memcpy(LpROW, LpTOP, nTextureWidth);
	memcpy(LpTOP, LpBOT, nTextureWidth);
	memcpy(LpBOT, LpROW, nTextureWidth);
                                  				} 
LocalFree(LpROW);
//end FLIP =============================================================										



f=CreateFile("maska.raw", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, 0 );
WriteFile( f, LpBuffer, nTextureWidth*nTextureHeight, #bytes_count, NULL );
CloseHandle(f);
//



//   ==========================================================
LpMaskaFrame=LocalAlloc(LPTR, nFrameWidth*nFrameHeight);

		for( y = 0; y < dst_height; y++) {
			y_src = y * src_pitch;
			y_dst = y * dst_pitch;
			for( x = 0; x < dst_width; x++) {
				// get bit at (y, x) in src image
//				value = (src_bits[y_src + ((left+x) >> 3)] & (0x80 >> ((left+x) & 0x07))) != 0;
//                                 DSBYTE[y_src+LpBuffer];
				// set bit at (y, x) in dst image
//				value ? dst_bits[y_dst + (x >> 3)] |= (0x80 >> (x & 0x7)) : dst_bits[y_dst + (x >> 3)] &= (0xff7f >> (x & 0x7));
			}//for
		}//for

LocalFree(LpMaskaFrame);	
//================================================================================

//
LocalFree(LpBuffer);	

//f = fopen ("maska.raw", "w");
//fwrite( #b, sizeof(BYTE), 1, f );
//	fclose (f);

//==========================================================
/*
f=CreateFile("maska.raw", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, 0 );

offset1=488*4;  //512 - 64 = 488
for (i=0; i<64; i++) {
                      for (k=0; k<64; k++) 
                             {
															
											        EAX=DSDWORD[i*4+LpRGBA];
	                            b=AL;
	WriteFile( f, #b, 1, #bytes_count, NULL );
											         
										          }//for
															LpRGBA+=offset1;
                       }//for

CloseHandle(f);
*/

}
