
#ifndef M_PI
#define M_PI 3.14159265358979323846    
#endif

#ifndef cosf
#define cosf(a) (float)cos(a)
#endif

#ifndef sinf
#define sinf(a) (float)sin(a)
#endif

#ifndef sqrtf
#define sqrtf(a) (float)sqrt(a)
#endif



#define PI_DIVBY_180 0.017453f                   

//#define DEG2RAD(a) ((float)(a) * PI_DIVBY_180)
//#define RAD2DEG(a) (((float)(a) / M_PI) * 180.0f)

#define DEG2RAD(a) float a*PI_DIVBY_180;
#define RAD2DEG(a) float a / M_PI * 180.0f;


#ifndef PI
#define PI 3.14159265358979323846
#endif


//--------------------------------------------------------------------------------------------------------
//   ⢥ ᫠  楫 ? 
:int truncate (float x)
{ 

$        FLD     x  
$        SUB     ESP, 12             
$        FIST    SSDWORD[ESP]     
$        FST     SSDWORD[ESP+4]   
$        FISUB   SSDWORD[ESP]     
$        FSTP    SSDWORD[ESP+8]   
$        POP     EAX                 
 
$        POP     ECX                 
$        POP     EDX                 
$        TEST    ECX, ECX            
$        JS      SHORT NEGATIVE 
$        ADD     EDX, 7FFFFFFFH      
$        SBB     EAX, 0              
return;        

NEGATIVE: 
$        XOR     ECX, ECX 
$        TEST    EDX, EDX 
$        SETG    CL                  
$        ADD     EAX, ECX            
}

//------------------------------------------------------------------------------------------


//⢥  楫  㣫
:ftol:
$db 0x55, 0x8B, 0xEC, 0x83, 0xC4, 0xF4, 0x9B, 0xD9, 0x7D, 0xFE, 0x9B, 0x66, 0x8B, 0x45, 0xFE, 0x80 
$db 0xCC, 0x0C, 0x66, 0x89, 0x45, 0xFC, 0xD9, 0x6D, 0xFC, 0xDF, 0x7D, 0xF4, 0xD9, 0x6D, 0xFE, 0x8B 
$db 0x45, 0xF4, 0x8B, 0x55, 0xF8, 0xC9, 0xC3                          

:int float2int(float a) 
{
$FLD a; $CALL ftol;
}


//--------------------------------------------------------------------------------------------------------
//砩 ᫮ ᯮ MSVCRT.H--
:float Rand1()
{
rand();     //  MSVCRT.H--
$PUSH EAX
$FILD SSDWORD[ESP]
$FSTP SSDWORD[ESP]
$POP  EAX
}
//--------------------------------------------------------------------------------------------------------
//
//------------------------------------------------------------------
//  Swap bitmap format from BGR to RGB
//------------------------------------------------------------------
:void SwapRGB(DWORD Pointer,  Size)
{

EBX=Pointer;
ECX=Size;

@loop1:
$  mov al, DSBYTE[ebx+0]
$  mov ah, DSBYTE[ebx+2]
$  mov DSBYTE[ebx+2],al
$  mov DSBYTE[ebx+0],ah
$  add ebx,3
$  dec ecx
$  jnz loop1

}


:void SwapRGBA(DWORD Pointer,  Size)
{
	EBX=Pointer;
	ECX=Size;
	loop(ECX){
		DSBYTE[EBX]><DSBYTE[EBX+2];
		EBX+=4;
	}
}
//--------------------------------------------------------------------------------------------------------
//䨭 
//p = p1 + t * (p2 - p1)
//Index  ᨢ
//LpShape 㪠⥫   ࠧ
//LpMorph ⥪騩
//LpOutTemp 
//shape_numpts -᫮  䨭
//t1 ६  0~1.0f
:void stdcall morph1(DWORD Index, LpShape, LpMorph, LpOutTemp, shape_numpts, float t1)
{

EBX=Index*4+LpShape;
ECX=shape_numpts;
ESI=Index*4+LpMorph;
EDI=LpOutTemp;


asm {



morph:
        //p = p1 + t * (p2 - p1)
        fld     DSFLOAT[esi]
        fmul    t1
        fld     DSFLOAT[esi + 4]
        fmul    t1
        fld     DSFLOAT[esi + 8]
        fmul    t1                     //z, y, x
        fxch    st(2)                  //x, y, z
        fadd    DSFLOAT[ebx]         
        fxch    st(1)                  //y, x, z
        fadd    DSFLOAT[ebx + 4]     
        fxch    st(2)                  //z, x, y
        fadd    DSFLOAT[ebx + 8]     
        fxch    st(1)                  //x, z, y
        fstp    DSFLOAT[edi]           //z, y
        fxch    st(1)                  //y, z
        fstp    DSFLOAT[edi + 4]        //z
        fstp    DSFLOAT[edi + 8]

        add     ebx, 16 //⭮ 㢥稢  16 ⮬     4  x, y, z, flag
        add     esi, 16
        add     edi, 16
        dec     ecx
        jnz     morph



    }

}



//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
:float degreesToRadians(float deg) 
{
float Result;
 
Result= deg * PI / 180.0f;


return Result;
 }


:float radiansToDegrees(float rad) 
{
float Result;
 
Result= rad * 180.0f / PI;


return Result;
 }

//-----------------------------------------------------------------------------------------------------------------------------------

