#define NR_WAVES 24
//#define NR_WAVES 4

float wrot[NR_WAVES],wtime[NR_WAVES],wr[NR_WAVES],wg[NR_WAVES],wb[NR_WAVES],wspd[NR_WAVES],wmax[NR_WAVES];
float v1=0.0,v2=0.0,v3=0.0;
int idTextureWave;

void initWaveTex()
{

InitIDTextureJPEG("smoke.jpg");
idTextureWave=JpegOLE.ID_Tex;
}

deinitWaveTex()
{

//glDeleteTextures(1, #ID_PNG);
EAX=#idTextureWave;
glDeleteTextures(1, EAX);

}


void initWave(int nr)
//uses allregs
{
float temp1;


        $MOV EAX, nr
//	wtime[nr]=0.0;
        $MOV DSDWORD[EAX*4+#wtime], 0;
//	wrot[nr]=getRandomMinMax( 0.0, 360.0 );
        getRandomMinMax( 0.0, 360.0 );
        $MOV EBX, nr
        $MOV DSDWORD[EBX*4+#wrot], EAX

//	wr[nr]  =getRandomMinMax( 0.0, 1.0 );
//	wg[nr]  =getRandomMinMax( 0.0, 1.0 );
//	wb[nr]  =getRandomMinMax( 0.0, 1.0 );
	getRandomMinMax( 0.0, 1.0 );
        $MOV EBX, nr
        $MOV DSDWORD[EBX*4+#wr], EAX

	getRandomMinMax( 0.0, 1.0 );
        $MOV EBX, nr
        $MOV DSDWORD[EBX*4+#wb], EAX

	getRandomMinMax( 0.0, 1.0 );
        $MOV EBX, nr
        $MOV DSDWORD[EBX*4+#wg], EAX

//       temp1= getRandomMinMax( 0.0, 0.3 );
//       wspd[nr]=0.5+ temp1;

	temp1=getRandomMinMax( 0.0, 0.3 );
        temp1+=0.5;
        $MOV EBX, nr
        DSFLOAT[EBX*4+#wspd]=temp1;


       temp1= getRandomMinMax( 0.0, 1.0 );
       temp1+=1.0;
//	wmax[nr]=1.0+ temp1;
       $MOV EBX, nr
       DSFLOAT[EBX*4+#wmax]=temp1;

}

void InitTabWave()

{
int i;
float temp1;


	FOR(i=0;i<NR_WAVES;i++)
	{



		initWave(i);
                temp1=getRandomMinMax( 0.0, 1.0 );
                temp1+=3.0;
		wtime[i]=temp1;

	}



}


void drawWave(int nr, float fDeltaTime)
{
	float colMod=1.0;
	float temp1;
	float temp2;
	float temp3;



	glPushMatrix();



	glScalef(wtime[nr],wtime[nr],wtime[nr]);

//	if(wtime[nr]>(wmax[nr]-1.0)) colMod=wmax[nr]-wtime[nr];

	EBX=nr;
	temp1=DSFLOAT[EBX*4+#wmax]-1.0;
	EBX=nr;
	temp2=DSFLOAT[EBX*4+#wtime];

	IF(temp2>temp1) //colMod=wmax[nr]-wtime[nr];
	{
	EBX=nr;
	colMod=DSFLOAT[EBX*4+#wmax]-DSFLOAT[EBX*4+#wtime];
        }
	zaplatka1();

	EBX=nr;
	temp1=DSFLOAT[EBX*4+#wrot];
//	glRotatef( wrot[nr], 1.0, 0.0, 0.0 );
//	glRotatef( wrot[nr], 0.0, 1.0, 0.0 );
//	glRotatef( wrot[nr], 0.0, 0.0, 1.0 );
	glRotatef( temp1, 1.0, 0.0, 0.0 );
	glRotatef( temp1, 0.0, 1.0, 0.0 );
	glRotatef( temp1, 0.0, 0.0, 1.0 );


//	glColor3f(colMod*wr[nr],colMod*wg[nr],colMod*wb[nr]);
	EBX=nr;
	temp1=DSFLOAT[EBX*4+#wr];
	temp2=DSFLOAT[EBX*4+#wg];
	temp3=DSFLOAT[EBX*4+#wb];
	glColor3f(colMod*temp1,colMod*temp2,colMod*temp3);



	glBegin( GL_QUADS );
	glTexCoord2f( 0.0, 0.0     );
	glVertex3f  (-1.0,-1.0, 0.0);
	glTexCoord2f( 1.0, 0.0     );
	glVertex3f  ( 1.0,-1.0 ,0.0);
	glTexCoord2f( 1.0, 1.0     );
	glVertex3f  ( 1.0, 1.0, 0.0);
	glTexCoord2f( 0.0, 1.0     );
	glVertex3f  (-1.0, 1.0, 0.0);
	glEnd();


//       temp1=fDeltaTime*wspd[nr];
//	wtime[nr]=wtime[nr]+temp1;
        $MOV EAX, nr;
	$FLD DSFLOAT[EAX*4+#wspd]
	$FMUL fDeltaTime
	$FADD DSFLOAT[EAX*4+#wtime]
	$FSTP DSFLOAT[EAX*4+#wtime]


//	if(wtime[nr]>wmax[nr]) initWave(nr);
//	zaplatka1();
	EBX=nr;
	temp1=DSFLOAT[EBX*4+#wtime];
	temp2=DSFLOAT[EBX*4+#wmax];
	IF(temp1>temp2) initWave(nr);

	glPopMatrix();

}


void RenderWave(float fDeltaTime)
{

	int i;

        glPushAttrib( GL_TEXTURE_BIT | GL_DEPTH_TEST | GL_LIGHTING );

	glEnable(GL_TEXTURE_2D);
        glDisable( GL_DEPTH_TEST );
        glDisable( GL_LIGHTING );

	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, idTextureWave);


//	glClear( GL_COLOR_BUFFER_BIT );
	glPushMatrix();

	glRotatef(v1, 1.0, 0.0, 0.0 );
	glRotatef(v2, 0.0, 1.0, 0.0 );
	glRotatef(v3, 0.0, 0.0, 1.0 );

	v1+=fDeltaTime*5.0;
	IF(v1>360.0) v1-=360.0;

	v2+=fDeltaTime*10.0;
	IF(v2>360.0) v2-=360.0;

	v3+=fDeltaTime*7.0;
	IF(v3>360.0) v3-=360.0;

	FOR(i=0;i<NR_WAVES;i++) drawWave(i, fDeltaTime);

	glPopMatrix();

        glDisable(GL_TEXTURE_2D);
        glPopAttrib();

}
