struct vect
{
float x;
float y;
float z;
};


#define RAND_MAX 0x7fff //  7fffh=32767

:dword Rand;

:void InitRand32()
{
	$rdtsc
	Rand=EAX>>2+1;
}


:dword Rand32()
{
$MOV  EAX,  Rand
$IMUL EAX,  EAX,343FDh
$ADD  EAX,  269EC3h
$MOV  Rand, EAX
$MOV  EAX,  Rand
$SAR  EAX,  10h
$AND  EAX,  RAND_MAX
}

//  頥
:DWORD stdcall Rand32D(dword base)
{
	$push EDX
	EAX=Rand/127773;
	EAX><EDX;
	$push EDX
	EAX=EAX*16807;
	$pop EDX
	EAX><EDX;
	$push EDX
	EAX=EAX*2836;
	$pop EDX
	EDX-=EAX;
	Rand=EAX=EDX;
	EAX=EAX%base;
	$pop EDX
}




//------------------------------------------------------------
//DSFLOAT[#६]=getRandomMinMax(min, max);
:float getRandomMinMax( float fMin, float fMax )
//uses allregs
{
float fRandNum, fDif;

//fRandNum = float Rand() / RAND_MAX;
fRandNum = Rand32();
$fild fRandNum;
$fstp fRandNum;
fRandNum =  fRandNum / RAND_MAX;
//    return fMin + (fMax - fMin) * fRandNum;

fDif= fMax - fMin;
fRandNum=fRandNum*fDif;
fRandNum+=fMin;

return fRandNum;
//$fld fRandNum;
//$wait;

}

// Name: getRandomVector()
// Desc: Generates a random vector where X,Y, and Z components are between
//       -1.0 and 1.0
//-----------------------------------------------------------------------------


#define OGL_PI 3.141592654f



:void getRandomVector(DWORD LpInVec, float t)
{
vect vVector;
static float radius, TempV;



    // Pick a random Z between -1.0f and 1.0f.
//    DSFLOAT[#vVector+#vect.z] = getRandomMinMax( -1.0f, 1.0f );
    getRandomMinMax( -1.0f, 1.0f );
    DSDWORD[#vVector+#vect.z] =  EAX;


    // Get radius of this circle
//    float radius = (float)sqrt(1 - vVector.z * vVector.z);
radius=DSFLOAT[#vVector+#vect.z] * DSFLOAT[#vVector+#vect.z];
radius=1.0f-radius;                   
radius=sqrt(radius);


    // Pick a random point on a circle.
//DSFLOAT[#t] = getRandomMinMax( -OGL_PI, OGL_PI );
getRandomMinMax( -OGL_PI, OGL_PI );
DSDWORD[#t] = EAX; 


    // Compute matching X and Y for our Z.
//    vVector.x = (float)cosf(t) * radius;
TempV=cos(t);
TempV=TempV*radius;
vVector.x=TempV;





//    vVector.y = (float)sinf(t) * radius;
TempV=sin(t);
TempV=TempV*radius;
vVector.y=TempV;


DSFLOAT[LpInVec+#vect.x] = DSFLOAT[#vVector+#vect.x]; 
DSFLOAT[LpInVec+#vect.y] = DSFLOAT[#vVector+#vect.y];
DSFLOAT[LpInVec+#vect.z] = DSFLOAT[#vVector+#vect.z];


//return vec;
}
