// ૨



:st Noise2D(int x, int y)
{

/*
  int n = x + y * 57;
  n = (n<<13) ^ n;
  return ( 1.0f - ( (n * (n * n * 15731 + 789221) + 1376312589) & 0x7fffffff) /
      1073741824.0f);
*/
int n;
double f_1=1073741824.0; 

n= 57*y + x;
n=n<<13^n;

$mov         ecx,n
$imul        ecx,n
$add         ecx,3E18Fh
$mov         edx,n
$imul        edx,ecx
$add         edx,1373F0B3h
$and         edx,7FFFFFFFh
$mov         n,edx

st(0)= n / f_1;


}
 





:st InterpolateLin (float a, float b, float c)
{

//	return a * (1 - c) + b * c;

$FLD1 
$FSUB  c
$FMUL  a
$FLD   b
$FMUL  c
$FADDP ST(1),ST(0)


}




:float InterpolateCub (float a, float b, float c)
{
float c2, tmp;
	//return a * (3*powf(1-c, 2) - 2*powf(1-c,3)) + b * (3*powf(c, 2) - 2*powf(c, 3));

	c2 = c * c;
//	c2 = c2 * 3 - c * c2 * 2;
        c2 = c2 * 3.0;
        tmp=c * c2 * 2.0;
        c2-=tmp;


//	return a * (1 - c2) + b * c2;
        tmp= 1- c2 * a + b * c2;

        return tmp;
}


:float InterpolateCos (float a, float b, float c)
{
        float ft, tmp;

	ft = cos (c * PI);
//	ft = (1 + ft)/2;
        ft = 1.0 + ft / 2.0;

//	return a*ft +b*(1-ft);
        tmp = a*ft; ft= 1-ft * b; tmp+=ft;
        return tmp;
}




:st SmoothedNoise2D(float f_x, float f_y)
{


float corners, sides, center;
float tmp1, tmp2, tmp3, tmp4;
int x, y;

$FLD f_x; $FISTP x;
$FLD f_y; $FISTP y;


tmp1=Noise2D(x-1, y-1);
tmp2=Noise2D(x+1, y-1);
tmp3=Noise2D(x-1, y+1);
tmp4=Noise2D(x+1, y+1);
corners=tmp1+tmp2+tmp3+tmp4/16.0f;

tmp1=Noise2D(x-1, y);
tmp2=Noise2D(x+1, y);
tmp3=Noise2D(x, y-1);
tmp4=Noise2D(x, y+1);
sides=tmp1+tmp2+tmp3+tmp4/8.0f;

center=Noise2D(x, y) / 4.0f;


$fld  corners
$fadd sides 
$fadd center

  }



//㭪,  頥 祭 ᣫ  
//௮஢ 㬠 
st CompileNoise(float x, float y) 
{


float int_X, int_Y, fractional_X, fractional_Y, v1,  v2, v3, v4, i1, i2, result;

truncate(x);    //楫   x
$push EAX
$FILD SSFLOAT[ESP]
$FSTP int_X
$ADD ESP, 4

fractional_X = x - int_X; //஡  


truncate(y);    //楫   y
$push EAX
$FILD SSFLOAT[ESP]
$FSTP int_Y
$ADD ESP, 4

fractional_Y = y - int_Y; //஡  y

  //砥 4 ᣫ 祭
      v1 = SmoothedNoise2D(int_X,       int_Y);
      v2 = SmoothedNoise2D(int_X + 1.0, int_Y);
      v3 = SmoothedNoise2D(int_X,       int_Y + 1.0);
      v4 = SmoothedNoise2D(int_X + 1.0, int_Y + 1.0);


  //௮㥬 祭 1  2   ந ௮  
       i1 =    InterpolateLin(v1 , v2 , fractional_X);
       i2 =    InterpolateLin(v3 , v4 , fractional_X);
       result= InterpolateLin(i1 , i2 , fractional_Y);


return result;
}




int PerlinNoise_2D(float x,float y,float factor, int NUM_OCTAVES)
{
float total;
float persistence;
float frequency;
float amplitude;
int i, result;
float tmp1, tmp2;
float f255=255.0f;

total = 0;
//  ᫮    㣨 祭  cosf(sqrtf(2))*3.14f 
//  ⮡ 뫮 ᨢ  १  ࠨ
persistence=0.5f;

// ᯥਬ  ⨬ 祭ﬨ, ஡ ⠢ 
// ਬ sqrtf(3.14f)*0.25f  - 殮   J)
frequency = 0.25f;
amplitude=1.0;




   //  䠪 砩, ⮡   뫨 ᥣ 묨
   // (    - 㬠 ७⭠?) 
   x+= factor;
   y+= factor;


   // NUM_OCTAVES - ६,  砥 ᫮ ⠢,
   // 祬  ⠢, ⥬  砥 
   for(i=0;i<NUM_OCTAVES;i++)
   {

//       total += CompileNoise(x*frequency, y*frequency) * amplitude;
//       amplitude *= persistence;
//       frequency*=2;
tmp1=x*frequency;
tmp2=y*frequency;
total += CompileNoise(tmp1, tmp2) * amplitude;
amplitude *= persistence;
frequency*=2.0;


    }
    //  ॢ 祭 梥    - 㫥
    //ਬ:

/*
total=sqrt(total);
total=total*total;
total=sqrt(1.0f/total); 
total=255.0-total; //-..     १
$FLD total
$FABS
$FISTP result

return result;
*/

//    total=fabsf(total);
//    int res=int(total*255.0f);//ਢ 梥  祭 0-255:



$FLD total
$FABS
$FMUL f255
$FISTP result


    return result;


}













//---------------------
struct colorA{
byte RED;
byte GREEN;
byte BLUE;
byte ALPHA;

};

#define width_tex  32;
#define height_tex 32;
byte image[width_tex*height_tex];
byte image2[width_tex*height_tex];
unsigned int image3[width_tex*height_tex];

int ID_TEX1_NOISE;

float tNoise;
float tN1;
float tN2;
float fd1, fd2;
int iN;

InitTexNoise()
{
int i, j;
float x_tex, y_tex;
int ic;
float rnd;




 

 







	for (i=0; i<=width_tex - 1; i++)
	      {
		for (j=0; j<=height_tex - 1; j++)
		{
//			image[i][j] = 255*Noise ((float)i/width*50, (float)j/height*50, 0, 1, 0);
//                        x_tex = float i/width_tex*50.0;
//                        y_tex = float j/height_tex*50.0;
                          $FILD i; $FSTP x_tex;
                          $FILD j; $FSTP y_tex;

                          rnd=getRandomMinMax( 0.0, 4.0);


//                        ic= PerlinNoise_2D(x_tex, y_tex, rnd,  1);
                          DSBYTE[width_tex*j+i+#image]= PerlinNoise_2D(x_tex, y_tex, rnd,  1);

//( + ⢮_⮢__ப * ࠧ_ * i+j) 



//                          DSBYTE[width_tex*i+j*4+#image]=ic;



		}
//                          DSBYTE[width_tex*i+j*4+#image]=255;


	}	



//	                   j=63;
//	                  for (i=0; i<=width_tex-1; i++)
//                          DSBYTE[width_tex*j+i+#tempimg]=255;
//                          DSBYTE[width_tex*j+i+#tempimg]=255;



/*



	                  for (i=0; i<=width_tex*height_tex-1; i++)
	                  {
	                  $xor EAX, EAX
			  AL=tempimg[i];
                          image[i]=EAX;

//                          $xor EAX, EAX
//                         $MOV AL, 255
//                          $LEA EBX, image 
//                          $ADD EBX, 3
//                          $MOV DSBYTE[ESI*4+EBX],AL
                          }


//                		image[2][2] = 255;
//                        DSDWORD[width_tex*2+2+#image]=255;

*/







//====
}
			 
// + ( * ࠧ )



InitNoiseGen()
{
			InitTexNoise(); 
                     	CopyMemory (#image2, #image,  sizeof(image2));

}




//-----------------------
NoiseMorph(float t1)
{

// ---------------------------------------------------------------------------------------------
tNoise+=t1;
if (tNoise > 1.0f) { 


                     	CopyMemory (#image2, #image,  sizeof(image2));



			InitTexNoise(); 


                        tNoise=0.0f; //// ⥪ 㬠




	  		}




//zaplatka1();





tN1=tNoise;
tN2=1.0f-tNoise; // ᮮ⢥⢥  ன


  for (iN=0; iN<width_tex*height_tex;iN++)
  {
    // 塞 १ ⥪
//    Result[i]=gNoise[i]*t2+gNoise2[i]*t1;

      fd1=image[iN]*tN1;
      fd2=image2[iN]*tN2;

//      image3[iN]=fd1+fd2;
        $FLD   fd1
        $FADD  fd2
        $PUSH  EAX
        $FISTP  SSFLOAT[ESP]
        $POP   EAX

      EBX=#image3+2;
      $MOV DSBYTE[ESI*4+EBX],AL
      $INC EBX
      $MOV DSBYTE[ESI*4+EBX],255


  }



}